package SQ.Columns.Databanks;

import com.strategyquant.lib.*;
import com.strategyquant.datalib.*;
import com.strategyquant.tradinglib.*;

public class AnnualReturnPctDdPctOnInitial extends DatabankColumn {
    
	public AnnualReturnPctDdPctOnInitial() {
		super("Annual % Return / DD% on Initial", 
          DatabankColumn.Decimal2, // value display format
          ValueTypes.Maximize, // whether value should be maximized / minimized / approximated to a value   
          0, // target value if approximation was chosen  
          0, // average minimum of this value
          5); // average maximum of this value
		
    setWidth(80); // defaultcolumn width in pixels
    
		setTooltip("Annual % Return / DD% on Initial");
    setDependencies("Drawdown");
	}

	@Override
	public double compute(SQStats stats, StatsTypeCombination combination, OrdersList ordersList, SettingsMap settings, SQStats statsLong, SQStats statsShort) throws Exception {
		double initialCapital = settings.getDouble("MoneyManagement.InitialCapital", 10000);
    double dd = stats.getDouble("Drawdown");
    double ddPctOnInitial = safeDivide(dd, initialCapital) * 100;
    double annualPctReturn = stats.getDouble("AnnualPctReturn");
    return safeDivide(annualPctReturn, ddPctOnInitial);
	}
}
